%define pydiodir %{_datadir}/pydio
Name: pydio
Version:  6.0.8
Release:  1%{?dist}.lux.1
Summary: Build your own box with Pydio : web RIA, mobile applications, desktop sync

Group: Applications/Publishing
License: AGPL
Vendor: Abstrium SAS
URL: http://pyd.io/
Source0: http://sourceforge.net/projects/ajaxplorer/files/ajaxplorer/stable-channel/%{version}/pydio-core-%{version}.zip
Source1: %{name}.conf
# Taken from pydio.conf, with httpd-2.4 stuff and died directoryes where we remove .htaccess and index.html below
# KEEP IT UP TO DATE
Source100: %{name}.conf.c7

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: php php-xml php-gd
Requires: php-mcrypt
Requires(post): policycoreutils-python
Requires(postun): policycoreutils-python

%description
Pydio is a web-based browser for managing files on a web server without FTP. Fully loaded
 with file formats preview, extended sharing, multidevice support and access control management
 it is the perfect tool to replace (drop)box and alikes in the enterprise.

%prep

%setup -q -n %{name}-core-%{version}

sed -i 's/"zip"/"rpm"/g' base.conf.php
sed -i 's/AJXP_INSTALL_PATH."\/conf"/"\/etc\/pydio"/g' base.conf.php

#schiavo -c conf/bootstrap_context.php
sed -i 's/AJXP_DATA_PATH."\/cache"/"\/var\/cache\/pydio"/g' conf/bootstrap_context.php
sed -i 's/AJXP_INSTALL_PATH."\/data\/cache"/"\/var\/cache\/pydio"/g' conf/bootstrap_context.php
sed -i 's/AJXP_INSTALL_PATH."\/data"/"\/var\/lib\/pydio"/g' conf/bootstrap_context.php
sed -i 's/\/\/ define("AJXP_FORCE_LOGPATH/define("AJXP_FORCE_LOGPATH/g' conf/bootstrap_context.php
#exit 1

# Update Share URL
sed -i 's/"AJXP_INSTALL_PATH\/data\/public"/"\/var\/lib\/pydio\/public"/g' plugins/core.ajaxplorer/manifest.xml
sed -i 's/name="PUBLIC_DOWNLOAD_URL" default=""/name="PUBLIC_DOWNLOAD_URL" default="\/pydio_public"/g' plugins/core.ajaxplorer/manifest.xml

# remove useless .htaccess and index.html; instead place restrictions in in pydio.conf. I leave only the .htaccess for directoryes in /var/lib/pydio, which might be shared
rm conf/{.htaccess,index.html} data/cache/{.htaccess,index.html} data/logs/{.htaccess,index.html}


%build

%install
rm -rf %{buildroot}

# copy application
install -d %{buildroot}%{pydiodir}
cp -pr . %{buildroot}%{pydiodir}

# apache conf
mkdir -p %{buildroot}%{_sysconfdir}/httpd/conf.d
cp -pr %SOURCE100 %{buildroot}%{_sysconfdir}/httpd/conf.d/%{name}.conf

# move conf to /etc
mv %{buildroot}%{pydiodir}/conf %{buildroot}%{_sysconfdir}/%{name}

# move data to /var
mkdir -p %{buildroot}%{_localstatedir}/lib
mv %{buildroot}%{pydiodir}/data %{buildroot}%{_localstatedir}/lib/%{name}

# Do it here instead of %post - adfgvx1
cp plugins/boot.conf/htaccess.tpl.linux %{buildroot}%{pydiodir}/.htaccess

# move cache to /var/cache
mkdir -p %{buildroot}%{_localstatedir}/cache
mv %{buildroot}%{_localstatedir}/lib/%{name}/cache %{buildroot}%{_localstatedir}/cache/%{name}

# move logs to /var/log
mkdir -p %{buildroot}%{_localstatedir}/log
mv %{buildroot}%{_localstatedir}/lib/%{name}/logs %{buildroot}%{_localstatedir}/log/%{name}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%{pydiodir}
#%{_sysconfdir}/%{name}/.htaccess
%config(noreplace) %{_sysconfdir}/%{name}/*
%config(noreplace) %{_sysconfdir}/httpd/conf.d/%{name}*.conf
%config(noreplace)  %attr(660,root,apache) %{pydiodir}/.htaccess
%attr(755,apache,apache) %{_localstatedir}/lib/%{name}
%dir %attr(755,apache,apache) %{_localstatedir}/cache/%{name}
#%{_localstatedir}/cache/%{name}/.htaccess
#%{_localstatedir}/cache/%{name}/index.html
%dir %attr(755,apache,apache) %{_localstatedir}/log/%{name}
#%{_localstatedir}/log/%{name}/.htaccess
#%{_localstatedir}/log/%{name}/*

%post
# Do in rpm
# chcon -R -t httpd_sys_content_t /usr/share/pydio/
# as suggested in https://www.howtoforge.com/tutorial/how-to-install-pydio-on-centos-7/
# see http://fedoraproject.org/wiki/PackagingDrafts/SELinux#File_contexts
semanage fcontext -a -t httpd_sys_content_t '%{pydiodir}(/.*)?' 2>/dev/null || :
restorecon -R %{pydiodir} || :

if [ -f "%{_localstatedir}/cache/%{name}/plugins_cache.ser" ]
then
# Upgrading an existing install
rm -f %{_localstatedir}/cache/%{name}/i18n/*.ser
rm -f %{_localstatedir}/cache/%{name}/plugins_*.ser
if [ ! -f "%{_localstatedir}/cache/%{name}/first_run_passed" ]
then
touch %{_localstatedir}/cache/%{name}/first_run_passed
fi
else
# Brand new install
# Why not distribute the right file? - adfgvx1
#cp -p %{pydiodir}/plugins/boot.conf/htaccess.tpl.linux %{pydiodir}/.htaccess
:
fi

%postun
if [ $1 -eq 0 ] ; then  # final removal
semanage fcontext -d -t httpd_sys_content_t '%{pydiodir}(/.*)?' 2>/dev/null || :
fi


%changelog
* Wed Jun 01 2013 Charles du Jeu <charls@ajaxplorer.info> - 5.0.0-1
- Add post install script

* Wed Jun 27 2012 Charles du Jeu <charles@ajaxplorer.info> - 4.2.0-1
- Update spec file, integrate in the phing automated process
- Replace the patch by sed commands (more line changes proof)

* Sun Dec 18 2011 Mathieu Baudier <mbaudier@argeo.org> - 4.0.0-1
- AjaXplorer v4 release

* Wed Dec 07 2011 Mathieu Baudier <mbaudier@argeo.org> - 3.3.6-0_20111206_2620
- Fix issue with logs paths
- Move VERSION and README back to conf

* Fri Dec 02 2011 Mathieu Baudier <mbaudier@argeo.org> - 3.3.5-1
- Initial packaging
